洛谷 P1463 [SDOI2005]反素数ant && P1820 寻找AP数
传送门1
传送门2
这个题又是一个双倍经验题。
对于这种题,我的思路从来都是:
1.暴力打表
2.找规律
3.试着写正解
首先打表,我当时打出了小于等于100000的所有符合条件的数,直接看也没看出来什么,然后当然就是老套路了–质因数分解,发现规律:
1.分解出来的质因数一定连续
2.质因数的幂次一定不上升
3.由(1)可得质因数最多10种
然后就可以dfs了,可以加各种剪枝:
1.可行性:小于等于n
2.最优性:约数个数大的替换小的
约数个数可以用这个算:
一边dfs一边更新就好了。
代码:
//0msAC
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cstdlib>
#include<cmath>
#include<vector>
#include<queue>
#define ll long long
using namespace std;
ll prime[100]={1,2,3,5,7,11,13,17,19,23,27,29,31};
ll ans;
ll n;
ll f;
void dfs(int i,ll num,ll x,int lim){
if(i>10)return;
if(x>n)return;
if(num>f||(f==num&&x<ans)){
ans=x;
f=num;
}
for(int j=1;j<=lim;j++){
x*=prime[i];
if(x>n)break;
dfs(i+1,num*(j+1),x,j);
}
}
int main(){
while(scanf("%lld",&n)==1){
ans=0;
f=0;
dfs(1,1,1,20);
printf("%lld\n",ans);
}
return 0;
}